#include "serverWrapper.h"

int main(int argc, char** argv) {
    /* Usage: server <port> <msg> */
    if(argc != 3) {
        fprintf(stderr, "Usage: %s <port> <msg>\n", argv[0]);
        return 1;
    }

    struct addrinfo hints = {};
    hints.ai_family     = AF_UNSPEC;
    hints.ai_socktype   = SOCK_STREAM;
    hints.ai_flags      = AI_PASSIVE;

    struct addrinfo* servAddrInfo;
    GetAddrInfo(NULL, argv[1], &hints, &servAddrInfo);

    struct addrinfo* ptr;
    int listenSockfd;
    for(ptr = servAddrInfo; ptr != NULL; ptr = ptr->ai_next) {
        if((listenSockfd = loopNewSocket(ptr->ai_family, 
                                        ptr->ai_socktype,
                                        ptr->ai_protocol)) == -1)
            continue;
        int reuseAddr = REUSEADDR;
        if(loopSetSockOpt(listenSockfd, SOL_SOCKET, 
                          SO_REUSEADDR, &reuseAddr, 
                          sizeof reuseAddr) == -1)
            continue;
        if(loopBind(listenSockfd, ptr->ai_addr, ptr->ai_addrlen) == -1)
            continue;
        if(loopListen(listenSockfd, LISTEN_BACKLOG) == -1)
            continue;
        break;
    }
    if(ptr == NULL) {
        fprintf(stderr, "No more address available.");
        freeaddrinfo(servAddrInfo);
        return 1;
    }

    freeaddrinfo(servAddrInfo);
    while(1) {
        struct sockaddr clientSockAddr;
        socklen_t clientSockAddrLen = sizeof clientSockAddr;
        int connSockfd = loopAccept(listenSockfd, &clientSockAddr, &clientSockAddrLen);
        if(connSockfd == -1)    continue;
        else {
            int msgLen = strlen(argv[2]);
            loopSend(connSockfd, argv[2], msgLen, 0);
        }
    }
    close(listenSockfd);
    return 0;
}